#
# spec file for package pgadmin4
#
# Copyright (c) 2023 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define pythons python3
%global python3_authlib_min_version 1.2.0
%global python3_azure_identity_min_version 1.13
%global python3_azure_mgmt_rdbms_min_version 10.1
%global python3_azure_mgmt_resource_min_version 23.0
%global python3_azure_mgmt_subscription_min_version 3.1
%global python3_bcrypt_min_version 4.0
%global python3_boto3_min_version 1.26
%global python3_botocore_min_version 1.31
%global python3_flask_babel_min_version 3.1.0
%global python3_flask_compress_min_version 1.4.0
%global python3_flask_gravatar_min_version 0.5.0
%global python3_flask_login_min_version 0.4.1
%global python3_flask_mail_min_version 0.9.1
%global python3_flask_migrate_min_version 4.0
%global python3_flask_min_version 2.3
%global python3_flask_paranoid_min_version 0.2.0
%global python3_flask_security_too_min_version 5.1.0
%global python3_flask_socketio_min_version 5.3.0
%global python3_flask_sqlalchemy_min_version 3.0
%global python3_flask_wtf_min_version 1.1
%global python3_httpagentparser_min_version 1.9
%global python3_google_api_python_client_min_version 2.0
%global python3_google_auth_oauthlib_min_version 1.0
%global python3_ldap3_min_version 2.5.1
%global python3_pillow_min_version 9.0
%global python3_pyotp_min_version 2.0
%global python3_keyring_min_version 23.0
%global python3_passlib_min_version 1.7.2
%global python3_psutil_min_version 5.9.0
%global python3_psycopg_min_version 3.1.8
%global python3_python_dateutil_min_version 2.8.0
%global python3_pytz_min_version 2023.0
%global python3_qrcode_min_version 7.0
%global python3_sqlalchemy_min_version 2.0
%global python3_sqlparse_min_version 0.3.0
%global python3_sshtunnel_min_version 0.1.5
%global python3_user_agents_min_version 2.2
%global python3_werkzeug_min_version 2.2
%global python3_wtforms_min_version 3.0

%global	pgadmin4instdir %{_libdir}/pgadmin4-%{version}
%global	pgadmin4homedir %{_localstatedir}/lib/pgadmin
%global user_group_name pgadmin

Name:           pgadmin4
Version:        7.8
Release:        1.1
Summary:        Management tool for PostgreSQL
License:        PostgreSQL
Group:          Productivity/Databases/Tools
URL:            http://www.pgadmin.org
Source0:        https://download.postgresql.org/pub/pgadmin/%{name}/v%{version}/source/%{name}-%{version}.tar.gz
Source1:        %{name}.conf.in
Source2:        %{name}.service.in
Source3:        %{name}.tmpfiles.d
Source4:        %{name}.desktop
Source7:        %{name}.uwsgi.in
Source8:        README.SUSE
Source9:        README.SUSE.uwsgi.in
Source10:       https://download.postgresql.org/pub/pgadmin/%{name}/v%{version}/source/%{name}-%{version}.tar.gz.asc
# https://www.pgadmin.org/download/pgadmin-4-source-code/
Source11:       %{name}.keyring
Source12:       vendor.tar.xz
Source13:       %{name}-desktop
Source99:       update-vendor.sh
Patch0:         use-os-makedirs.patch
Patch1:         fix-python3-crypto-call.patch
Patch2:         support-new-azure-mgmt-rdbms.patch
Patch3:         support-new-werkzeug.patch
Patch4:         support-new-flask.patch
Patch5:         fix-eventlet-select_epoll.patch
BuildRequires:  fdupes
BuildRequires:  hicolor-icon-theme
BuildRequires:  optipng
BuildRequires:  python-rpm-macros
BuildRequires:  python3-Authlib >= %{python3_authlib_min_version}
BuildRequires:  python3-Flask >= %{python3_flask_min_version}
BuildRequires:  python3-Flask-Babel >= %{python3_flask_babel_min_version}
BuildRequires:  python3-Flask-Compress >= %{python3_flask_compress_min_version}
BuildRequires:  python3-Flask-Gravatar >= %{python3_flask_gravatar_min_version}
BuildRequires:  python3-Flask-Login >= %{python3_flask_login_min_version}
BuildRequires:  python3-Flask-Mail >= %{python3_flask_mail_min_version}
BuildRequires:  python3-Flask-Migrate >= %{python3_flask_migrate_min_version}
BuildRequires:  python3-Flask-Paranoid >= %{python3_flask_paranoid_min_version}
BuildRequires:  python3-Flask-SQLAlchemy >= %{python3_flask_sqlalchemy_min_version}
BuildRequires:  python3-Flask-Security-Too >= %{python3_flask_security_too_min_version}
BuildRequires:  python3-Flask-SocketIO >= %{python3_flask_socketio_min_version}
BuildRequires:  python3-Flask-WTF >= %{python3_flask_wtf_min_version}
BuildRequires:  python3-SQLAlchemy >= %{python3_sqlalchemy_min_version}
BuildRequires:  python3-WTForms >= %{python3_wtforms_min_version}
BuildRequires:  python3-Werkzeug >= %{python3_werkzeug_min_version}
BuildRequires:  python3-azure-identity >= %{python3_azure_identity_min_version}
BuildRequires:  python3-azure-mgmt-rdbms >= %{python3_azure_mgmt_rdbms_min_version}
BuildRequires:  python3-azure-mgmt-resource >= %{python3_azure_mgmt_resource_min_version}
BuildRequires:  python3-azure-mgmt-subscription >= %{python3_azure_mgmt_subscription_min_version}
BuildRequires:  python3-bcrypt >= %{python3_bcrypt_min_version}
BuildRequires:  python3-boto3 >= %{python3_boto3_min_version}
BuildRequires:  python3-botocore >= %{python3_botocore_min_version}
BuildRequires:  python3-cryptography
BuildRequires:  python3-eventlet
BuildRequires:  python3-google-api-python-client >= %{python3_google_api_python_client_min_version}
BuildRequires:  python3-google-auth-oauthlib >= %{python3_google_auth_oauthlib_min_version}
BuildRequires:  python3-httpagentparser >= %{python3_httpagentparser_min_version}
BuildRequires:  python3-keyring >= %{python3_keyring_min_version}
BuildRequires:  python3-ldap3 >= %{python3_ldap3_min_version}
BuildRequires:  python3-passlib >= %{python3_passlib_min_version}
BuildRequires:  python3-pip
BuildRequires:  python3-psutil >= %{python3_psutil_min_version}
BuildRequires:  python3-psycopg >= %{python3_psycopg_min_version}
BuildRequires:  python3-pyotp >= %{python3_pyotp_min_version}
BuildRequires:  python3-python-dateutil >= %{python3_python_dateutil_min_version}
BuildRequires:  python3-pytz >= %{python3_pytz_min_version}
BuildRequires:  python3-qrcode >= %{python3_qrcode_min_version}
BuildRequires:  python3-sqlparse >= %{python3_sqlparse_min_version}
BuildRequires:  python3-sshtunnel >= %{python3_sshtunnel_min_version}
BuildRequires:  python3-testscenarios
BuildRequires:  python3-urllib3 < 2
BuildRequires:  python3-user-agents >= %{python3_user_agents_min_version}
BuildRequires:  python3-wheel
BuildRequires:  systemd-rpm-macros
BuildRequires:  yarn
Requires:       python3 >= 3.7
Requires:       python3-Authlib >= %{python3_authlib_min_version}
Requires:       python3-Flask >= %{python3_flask_min_version}
Requires:       python3-Flask-Babel >= %{python3_flask_babel_min_version}
Requires:       python3-Flask-Compress >= %{python3_flask_compress_min_version}
Requires:       python3-Flask-Gravatar >= %{python3_flask_gravatar_min_version}
Requires:       python3-Flask-Login >= %{python3_flask_login_min_version}
Requires:       python3-Flask-Mail >= %{python3_flask_mail_min_version}
Requires:       python3-Flask-Migrate >= %{python3_flask_migrate_min_version}
Requires:       python3-Flask-Paranoid >= %{python3_flask_paranoid_min_version}
Requires:       python3-Flask-SQLAlchemy >= %{python3_flask_sqlalchemy_min_version}
Requires:       python3-Flask-Security-Too >= %{python3_flask_security_too_min_version}
Requires:       python3-Flask-SocketIO >= %{python3_flask_socketio_min_version}
Requires:       python3-Flask-WTF >= %{python3_flask_wtf_min_version}
Requires:       python3-SQLAlchemy >= %{python3_sqlalchemy_min_version}
Requires:       python3-WTForms >= %{python3_wtforms_min_version}
Requires:       python3-Werkzeug >= %{python3_werkzeug_min_version}
Requires:       python3-azure-identity >= %{python3_azure_identity_min_version}
Requires:       python3-azure-mgmt-rdbms >= %{python3_azure_mgmt_rdbms_min_version}
Requires:       python3-azure-mgmt-resource >= %{python3_azure_mgmt_resource_min_version}
Requires:       python3-azure-mgmt-subscription >= %{python3_azure_mgmt_subscription_min_version}
Requires:       python3-bcrypt >= %{python3_bcrypt_min_version}
Requires:       python3-boto3 >= %{python3_boto3_min_version}
Requires:       python3-botocore >= %{python3_botocore_min_version}
Requires:       python3-cryptography
Requires:       python3-eventlet
Requires:       python3-google-api-python-client >= %{python3_google_api_python_client_min_version}
Requires:       python3-google-auth-oauthlib >= %{python3_google_auth_oauthlib_min_version}
Requires:       python3-httpagentparser >= %{python3_httpagentparser_min_version}
Requires:       python3-keyring >= %{python3_keyring_min_version}
Requires:       python3-ldap3 >= %{python3_ldap3_min_version}
Requires:       python3-passlib >= %{python3_passlib_min_version}
Requires:       python3-psutil >= %{python3_psutil_min_version}
Requires:       python3-psycopg >= %{python3_psycopg_min_version}
Requires:       python3-pyotp >= %{python3_pyotp_min_version}
Requires:       python3-python-dateutil >= %{python3_python_dateutil_min_version}
Requires:       python3-pytz >= %{python3_pytz_min_version}
Requires:       python3-qrcode >= %{python3_qrcode_min_version}
Requires:       python3-sqlparse >= %{python3_sqlparse_min_version}
Requires:       python3-sshtunnel >= %{python3_sshtunnel_min_version}
Requires:       python3-urllib3 < 2
Requires:       python3-user-agents >= %{python3_user_agents_min_version}
Suggests:       python3-mod_wsgi
Suggests:       %{name}-doc
Recommends:     %{name}-desktop
Obsoletes:      %{name}-web < %{version}
%{?systemd_requires}
BuildArch:      noarch

%description
pgAdmin 4 is a rewrite of the pgAdmin3 management tool for the
PostgreSQL database. It is written as a web application in Python,
using jQuery and Bootstrap for the client side processing and UI. On
the server side, Flask is being utilised.

This package contains the required files to run pgAdmin4 as a web application

%package	doc
Summary:        Documentation for pgAdmin4
Group:          Documentation/HTML

%description doc
pgAdmin 4 is a rewrite of the pgAdmin3 management tool for the
PostgreSQL database.

This package contains the documentation for pgadmin4.

%package web-uwsgi
Summary:        Pgamdin4 - uwsgi configuration
Group:          Productivity/Networking/Web/Utilities
Requires:       pgadmin4
Requires:       uwsgi

%description web-uwsgi
pgadmin4 is a management tool for PostgreSQL.

This package holds the uwsgi configuration.

%package desktop
Summary:        Desktop application for pgAdmin4
Group:          Documentation/HTML
Requires:       %{name}
Requires:       python3-PyQt6

%description desktop
pgAdmin 4 is a rewrite of the pgAdmin3 management tool for the
PostgreSQL database.

This package provides a small python script that can be used
to start pgAdmin4 as a regular user and provides a simple ui
as a system tray icon to open more windows or quit.

Note that his script is not related to the official pgAdmin4
runtime application and is NOT supported by the pgAdmin project
but only provided for convenience.

%prep
%autosetup -p1

sed -e 's@PYTHONSITELIB@%{python3_sitelib}@g' <%{SOURCE1} > %{name}.conf
sed -e 's@PYTHONDIR@%{_bindir}/python3@g' -e 's@PYTHONSITELIB@%{python3_sitelib}@g' < %{SOURCE2} > %{name}.service
sed -e 's@PYTHONDIR@%{_bindir}/python3@g' -e 's@PYTHONSITELIB@%{python3_sitelib}@g' < %{SOURCE4} > %{name}.desktop
sed -e 's@PYTHONSITELIB@%{python3_sitelib}@g' <%{SOURCE7} > %{name}.uwsgi
sed -e 's@PYTHONSITELIB@%{python3_sitelib}@g' <%{SOURCE9} > README.SUSE.uwsgi

# speaklater isn't really used
sed -i -e 's/^speaklater.*//' requirements.txt

cp %{SOURCE8} .
cp %{SOURCE9} .

# rpmlint
chmod -x docs/en_US/theme/pgadmin4/static/style.css
chmod -x docs/en_US/theme/pgadmin4/theme.conf
# This package is run using the interpreter so it doesn't need the executable bit set
chmod -x web/pgadmin/misc/bgprocess/process_executor.py
chmod -x web/pgadmin/static/fonts/*.ttf

# Uncompress the vendor sources
tar xvfJ %{SOURCE12}
# Use the system optipng, not the one built when creating the vendor package in the developer workstation
ln -s %{_bindir}/optipng web/node_modules/optipng-bin/vendor/optipng

# Do not use env as script interpreter
find web/node_modules -type f -executable -exec sed -i -e '1{s,^#! */usr/bin/env \(node\|python3|bash\),#!%{_bindir}/\1,}' "{}" \;
find web/pgacloud -type f -executable -exec sed -i -e '1{s,^#! */usr/bin/env \(node\|python3\),#!%{_bindir}/\1,}' "{}" \;

rm web/regression/.gitignore

%build
make bundle
rm -Rf web/node_modules web/yarn.lock

export EVENTLET_NO_GREENDNS='yes'
mkdir -p pip-build/pgadmin4
cp -a web/* pip-build/pgadmin4
echo recursive-include pgadmin4 \* > pip-build/MANIFEST.in
find pip-build -name '.gitignore' -o -name '.coverage*' -delete
cat << EOF > pip-build/pgadmin4/config_distro.py
# SERVER_MODE = True
MINIFY_HTML = False
HTML_HELP = '%{_datadir}/doc/%{name}-docs/en_US/html/'
UPGRADE_CHECK_ENABLED = False
DEFAULT_BINARY_PATHS = {
    "pg": "%{_bindir}"
}
EOF
pushd pip-build
python3 ../pkg/pip/setup_pip.py bdist_wheel
popd
mv -v pip-build/dist/*.whl .

%install
%pyproject_install
mkdir -p %{buildroot}%{_docdir}/%{name}
cp README.md %{buildroot}%{_docdir}/%{name}

install -d -m 755 %{buildroot}%{_docdir}/%{name}-docs/
cp -pr docs/* %{buildroot}%{_docdir}/%{name}-docs
find %{buildroot}%{_docdir}/%{name}-docs -name '.gitignore' -delete

install -d %{buildroot}%{_sysconfdir}/apache2/conf.d/
install -m 0644 -p %{name}.conf %{buildroot}%{_sysconfdir}/apache2/conf.d/%{name}.conf

# Install desktop file
install -d %{buildroot}%{_datadir}/applications/
install -m 0644 -p %{name}.desktop %{buildroot}%{_datadir}/applications/%{name}.desktop

# Install config system for webapp
install -d -m 0755 %{buildroot}%{_sysconfdir}/pgadmin/
echo "# SERVER_MODE = True" > %{buildroot}%{_sysconfdir}/pgadmin/config_system.py

# Install unit file/init script
# This is only for systemd supported distros:
install -d %{buildroot}%{_unitdir}
install -m 0644 -p %{name}.service %{buildroot}%{_unitdir}/%{name}.service

# ... and make a tmpfiles script to recreate it at reboot.
mkdir -p %{buildroot}/%{_tmpfilesdir}
install -m 0644 %{SOURCE3} %{buildroot}/%{_tmpfilesdir}/%{name}.conf

chmod -x %{buildroot}%{_docdir}/%{name}-docs/en_US/images/*
mkdir -p %{buildroot}%{_sbindir}
ln -s %{_sbindir}/service %{buildroot}%{_sbindir}/rcpgadmin4

install -d -m 0755 %{buildroot}%{pgadmin4homedir}
install -d -m 0755 %{buildroot}%{pgadmin4homedir}/storage
install -d -m 0700 %{buildroot}%{pgadmin4homedir}/sessions
install -d -m 0755 %{buildroot}%{_localstatedir}/log/pgadmin

install -d -m 0755 %{buildroot}%{_sysconfdir}/uwsgi/vassals
install -m 0644 %{name}.uwsgi %{buildroot}%{_sysconfdir}/uwsgi/vassals/pgadmin4.ini

install -d -m 0755 %{buildroot}%{_datadir}/icons/hicolor/256x256/apps
install -m 0644 web/pgadmin/static/img/logo-256.png %{buildroot}%{_datadir}/icons/hicolor/256x256/apps/pgadmin4.png

install -d -m 0755 %{buildroot}%{python3_sitelib}/%{name}/assets
install -m 0644 ./runtime/assets/welcome_logo.svg %{buildroot}%{python3_sitelib}/%{name}/assets/welcome_logo.svg

install -m 0755 %{SOURCE13} %{buildroot}%{_bindir}

%fdupes %{buildroot}%{python3_sitelib}

##%% check
## Requires Postgres running
##PYTHONPATH=%%{buildroot}%%{python3_sitelib} python3 -B web/regression/runtests.py --exclude feature_tests

%pre
/usr/sbin/groupadd -r %{user_group_name} &>/dev/null || :
/usr/sbin/useradd  -g %{user_group_name} -s /bin/false -r -c "%{name}" -d %{pgadmin4homedir} %{user_group_name} &>/dev/null || :
%service_add_pre %{name}.service

%post
%service_add_post %{name}.service
%tmpfiles_create %{_tmpfilesdir}/%{name}.conf

%preun
%service_del_preun %{name}.service

%postun
chown -R %{user_group_name}:%{user_group_name} %{pgadmin4homedir}
%service_del_postun %{name}.service

%files
%defattr(-,root,root,-)
%doc README.md README.SUSE
%license LICENSE
%{_bindir}/pgadmin4

%dir %{_sysconfdir}/apache2
%dir %{_sysconfdir}/apache2/conf.d
%config(noreplace) %{_sysconfdir}/apache2/conf.d/%{name}.conf

%{python3_sitelib}/%{name}
%{python3_sitelib}/%{name}-%{version}.dist-info

%{_unitdir}/%{name}.service
%{_tmpfilesdir}/%{name}.conf
%{_sbindir}/rcpgadmin4

%defattr(-,root,%{user_group_name})
%dir %{_sysconfdir}/pgadmin
%config(noreplace) %{_sysconfdir}/pgadmin/config_system.py

%defattr(-,%{user_group_name},%{user_group_name})
%ghost %dir %{_rundir}/%{name}
%dir %{pgadmin4homedir}
%dir %{pgadmin4homedir}/storage
%attr(700,%{user_group_name},%{user_group_name}) %dir %{pgadmin4homedir}/sessions
%dir %{_localstatedir}/log/pgadmin

%files doc
%defattr(-,root,root,-)
%dir %{_docdir}/%{name}-docs
%doc %{_docdir}/%{name}-docs/*

%files web-uwsgi
%defattr(-,root,root,-)
%doc README.SUSE.uwsgi
%dir %{_sysconfdir}/uwsgi
%dir %{_sysconfdir}/uwsgi/vassals
%config (noreplace) %{_sysconfdir}/uwsgi/vassals/pgadmin4.ini

%files desktop
%defattr(-,root,root,-)
%{_bindir}/pgadmin4-desktop
%{_datadir}/applications/%{name}.desktop
%{_datadir}/icons/hicolor/256x256/apps/pgadmin4.png

%changelog
* Mon Oct 30 2023 Antonio Larrosa <alarrosa@suse.com>
- Add obsoletes: pgadmin4-web
* Wed Oct 25 2023 Antonio Larrosa <alarrosa@suse.com>
- Add a vendor.tar.xz source package with node modules that have to
  be downloaded in the developer workstation since otherwise they
  won't be able to get downloaded in the build service.
- Add an update-vendor.sh script that updates (actually, recreates)
  the vendor.tar.xz package. This should be run manually with each
  package update.
- Remove obsoleted file pgadmin4.qt.conf.in which hasn't been used
  at all for some time.
- Add patch to set the environment variable EVENTLET_NO_GREENDNS
  which fixes pgadmin4 to build successfully with eventlet 0.33.3,
  httpcore 0.17.1 and httpx 0.24.0:
  * fix-eventlet-select_epoll.patch
- Merged pgadmin4-web subpackage into the main pgadmin4 package
  which now installs the pgAdmin4 server.
- Create new pgadmin4-desktop subpackage that includes a very small
  python script I wrote that starts the pgadmin4 server in runtime
  mode (as a regular user) and provides a system tray icon so users
  can open new windows and quit the server with a UI since the
  alternative (using the official pgAdmin4 runtime application
  would require providing a full node.js modules tree and using
  NW.js for the ui).
- Fix .desktop file which was now moved to the pgadmin4-desktop
  subpackage. The "Encoding" key is deprecated so it has been
  removed, only one main category is now used in the Categories
  key and the path to the icon was fixed.
- Remove pgadmin4.qt.conf.in which is not used anymore
* Wed Oct 25 2023 Antonio Larrosa <alarrosa@suse.com>
- Update to 7.8
  * Supported Database Servers
  - PostgreSQL: 12, 13, 14, 15, and 16
  - EDB Advanced Server: 12, 13, 14 and 15
  * Bundled PostgreSQL Utilities
  - psql, pg_dump, pg_dumpall, pg_restore: 16.0
  * New features
  - Add support for foreign table's new functionality for PG 11
    and above.
  - Allow setting custom username for shared servers, with
    default as username of server being shared.
  - Add 'GENERATED ALWAYS AS..' option while creating column
    constraints for Foreign Table.
  - GUI representation of the system's activity using the
    'system_stats' extension.
  - Added 'load_balance_hosts' connection string parameter
    for PG 16 and above.
  * Housekeeping
  - Use PG16 as the default PostgreSQL version.
  * Bug fixes
  - Fixed an issue in ERD tool where the downloaded images
    have a few links cut.
  - Fixed an issue where user was not able to assign new/old
    columns as primary key once column with primary key is
    deleted.
  - Add support for setting prepare threshold in server
    connection.
  - Fixed an issue where the wrong message "Current database
    has been moved or renamed" is displayed when debugging any
    function.
  - Fixed an issue where Processes tab displays wrong server
    name in some scenario.
  - Fix an issue where global/native keyboard shortcuts are
    not working when any cell of data output grid has focus.
  - Fixed query history slowness issue by storing query only for
    those having certain threshold max length.
  - Fix an issue where foreign table column name becomes "none"
    if the user changes any column data type.
  - Pin the cryptography version to fix PyO3 modules
    initialisation error.
  - Ensure that the backup works properly for PG 16 on the latest
    docker image.
  - Fixed an issue where the user is unable to select objects on
    the backup dialog due to tree flickering.
  - Fixed an issue where non-super PostgreSQL users are not able
    to terminate their own connections from dashboard.
  - Fix an issue where scale in columns is not allowed to have
    value as 0 or below.
  - Fix an issue in graphical explain plan where query tool
    crashes when the plan has parallel workers details and sort
    node is clicked for details.
  - Fix an issue where user login is not working if
    username/email contains single quote in server mode.
- Update to 7.7
  * Supported Database Servers
  - PostgreSQL: 11, 12, 13, 14 and 15
  - EDB Advanced Server: 11, 12, 13, 14 and 15
  * Bundled PostgreSQL Utilities
  - psql, pg_dump, pg_dumpall, pg_restore: 15.4
  * New features
  - Added support to select/deselect objects in the Backup
    dialog.
  - Added all the new options of the 'WITH' clause in the
    subscription dialog.
  - Added USING method while creating the table.
  - Added compression method option while creating a column.
  - Added Strategy, Locale Provider, ICU Locale, ICU Rules,
    and OID options while creating a database.
  - Added USING method while creating the materialized view.
  - Add support for additional ID token claim checks for
    OAuth 2 authentication.
  * Housekeeping
  - Added the ‘data type’ column in the properties tab of
    the Columns collection node.
  * Bug fixes
  - Fix an issue where user is not able to change the
    password when SMTP is not configured.
  - Ensure user is redirected to login page after failed login.
  - Ensure that Materialized view size fields in "Statistics"
    should be human-readable.
  - Fix an issue where changing the password shows success but
    the new password is not working.
  - Fix an issue where login form doesn't appear if internal
    auth source is removed.
  - Fix a security related issue where an authenticated user can
    run remote command using validate binary path API
    (CVE-2023-5002, boo#1215603).
* Fri Aug 25 2023 Simon Lees <simonf.lees@suse.com>
- Update to 7.6
  - Features:
  - Added Expression to CREATE INDEX.
  - Added cascade option while creating an extension.
  - Added ‘Ignore Grants’ option in the schema diff tool.
  - Added ‘Ignore Tablespace’ option in the schema diff tool.
  - Added support for ALTER INDEX column statistics.
  - Added unlogged option while creating a sequence.
  - Added all like options while creating a table.
  - Added support for SYSTEM, CONCURRENTLY and TABLESPACE options in REINDEX.
  - Added WAL option to EXPLAIN ANALYZE command.
  - Added new/missing options to the VACUUM command.
  - Added SKIP_LOCKED and BUFFER_USAGE_LIMIT option to Analyze command.
  - Add support for TRUNCATE trigger in foreign table.
  - Ensure that Schema Diff comparison results should be displayed in the sorted order.
  - Added support to detach partitions using concurrently and finalize.
  - Added all supported index storage parameters while creating an index.
  - Added new/missing parameters to pg_dumpall (Backup Server).
  - Added new/missing parameters to pg_dump (Backup Objects).
  - Added new/missing parameters to pg_restore.
  - Housekeeping:
  - Generate software bill of materials as part of the package builds.
  - Added support for PostgreSQL and EPAS 16 to ensure it works without any errors.
  - Remove Bootstrap and jQuery from authentication pages and rewrite them in ReactJS.
  - Enable cluster deployment with gp3 volume for AWS & BigAnimal cloud providers.
  - Clarify the LICENSE file to indicate that it is the PostgreSQL Licence.
  - Remove unsupported PostgreSQL versions from the container.
  - Bug fixes:
  - Fix incorrect redirection URL after authentication by removing fixed value set to SCRIPT_NAME environment variable in pgAdmin4.wsgi file.
  - Allow changing the POOL_SIZE and MAX_OVERFLOW config values of the pgAdmin config DB connection pool.
  - Fix an issue where query tool on shared server is throwing error if the pgAdmin config DB is external.
  - Fix the query tool issue where raise Notice from func/proc or code blocks are no longer displayed live.
  - Fix the issue where query tool window turns blank if the user tries to generate a graph on the result.
  - Fix an issue where changing MFA_SUPPORTED_METHODS breaks the MFA validation.
  - Fix an issue where pgAdmin 7.5 fails to render table SQL with extension loaded index method.
  - Fix an issue where cycle syntax was not added in SQL when creating new sequence from UI.
  - Fix an issue where the SET directive is excluded from the function header in the schema diff tool.
  - Fix a query tool error ‘pgAdminThread’ object has no attribute ‘native_id’.
  - Ensure keyboard shortcut for query execution is disabled when query execution is in progress.
  - Fix an issue where queries can’t complete execution.
  - Fixed an issue where Import Export not working when using pgpassfile.
  - Fix an issue where queries longer than 1 minute get stuck - Container 7.1
  - Fix an issue where queries get stuck with auto-completion enabled.
  - Fixed Query Tool/ PSQL tool tab title not getting updated on database rename.
  - Ensure user gets proper error if incorrect credentials are entered while authenticating AWS.
  - Fix an issue where the edit server fails in desktop mode if the server password is not stored.
  - Ensure that Backup, Restore, and Maintenance should work properly when pgpass file is used.
  - Fix the query tool auto-complete issue on the server reconnection.
  - Fix the query tool restore connection issue.
  - Fix the reconnecton issue if the PostgreSQL server is restarted from the backend.
  - Fix the connection and stability issues since v7, possibly related to background schema changes.
  - Fixed an issue where the query tool is unable to execute a query on Postgres 10 and below versions.
  - Fix the lost connection error in v7.4.
  - Fixed an issue where pgAdmin failed to setup role with hyphens in name.
  - Fixed an issue where filters are not working and query history shows empty queries.
  - Fix an issue where adding a sub-folder inside a folder is not working as expected in File Manager.
  - Fix an error ‘list’ object has no attribute ‘strip’ while attempting to populate auto-complete manually the first time.
  - Fixed an issue where ERD Tool can’t load the saved pgerd file from Shared Storage.
  - Fix an issue where inserting more than 10 rows does not work correctly in View Data; only parts end up in the table.
  - Add support-new-flask.patch to fix build with flask 2.3
* Mon Jul 31 2023 Steve Kowalik <steven.kowalik@suse.com>
- Update to 7.4, extremely large list of changes, partially chosen:
  * Make Statistics, Dependencies, Dependants tabs closable and the user
    can add them back using the 'Add panel' option.
  * Added support for Logical Replication.
  * Implemented runtime using NWjs to open pgAdmin4 in a standalone window
    instead of the system tray and web browser.
  * Added Quick Search functionality for menu items and help articles.
  * Added publication and subscription support in Schema Diff.
  * Use cheroot as the default production server for pgAdmin4.
  * Show the login roles that are members of a group role be shown when
    examining a group role.
  * Added '--replace' option in Import server to replace the list of
    servers with the newly imported one.
  * Added zoom scaling options with keyboard shortcuts in runtime.
  * Use schema qualification while accessing the catalog objects.
  * Make the 'Save Data Changes' icon to be more intuitive.
  * Improve code coverage and API test cases for Server module.
  * Added support to set auto width of columns by content size in the data
    output window.
  * Added support to connect PostgreSQL servers via Kerberos authentication.
  * Added "IF NOT EXISTS" clause while creating tables and partition tables
    which is convenient while using the ERD tool.
  * Added browse button to select the binary path in the Preferences.
  * Added Grant Wizard option under Package node.
  * Added support to launch PSQL for the connected database server.
  * Added window maximize/restore functionality for properties dialog.
  * Added support to set the binary path for the different database server
    versions.
  * Added OS, Browser, Configuration details in the About dialog.
  * Added support for rotating the pgAdmin log file on the basis of size
    and age.
  * Added RESQL/MSQL test cases for Table and its child nodes.
  * Updated Flask-Security-Too to the latest v4.
  * Added a mechanism to detect a corrupt/broken config database file.
  * Highlighted long running queries on the dashboards.
  * Added support for Reassign/Drop Owned for login roles.
  * Do not block the query editor window when running a query.
  * Added support for OAuth 2 authentication.
  * Added option to provide maximum width of the column when 'Resize by
    data?’ option in the preferences is set to True.
  * Added support to copy SQL from main window to query tool.
  * Added support for formatted JSON viewer/editor when interacting with
    data in a JSON column.
  * Rename the "Resize by data?" to "Columns sized by" and disabled the
    'Maximum column width' button if 'Columns sized by' is set to
    'Column data'.
  * Added support for the truncate table with restart identity.
  * Make code folding case insensitive in the code mirror.
  * Added database and server information on the Maintenance process watcher
    dialog.
  * Allow the referenced table to be the same as the local table in one to
    many relationship for ERD Tool.
  * Set PSQLRC and PSQL_HISTORY env vars to apt. user storage path in the
    server mode.
  * Added support for OWNED BY Clause for sequences.
  * Revisit all the CREATE and DROP DDL's to add appropriate 'IF EXISTS',
    'CASCADE' and 'CREATE OR REPLACE'.
  * Added support for indent guides in the browser tree.
  * Added support for advanced table fields like the foreign key, primary key in the ERD tool.
  * Added support to allow tables to be dragged to ERD Tool.
  * Added index creation when generating SQL in the ERD tool.
  * Added support for authentication via the webserver (REMOTE_USER).
  * Added support to enable/disable rules.
  * Added support of Aggregate and Operator node in view-only mode.
  * Ensure that users should be able to modify the REMOTE_USER environment
    variable as per their environment by introducing the new config
    parameter WEBSERVER_REMOTE_USER.
  * Added support for Two-factor authentication for improving security.
  * Added support to disable the auto-discovery of the database servers.
  * Replace Flask-BabelEx with Flask-Babel.
  * Upgrade Flask to version 2.
  * Added support to import/export server groups and servers from GUI.
  * Added support to open SQL help, Dialog help, and online help in an
    external web browser.
  * Rename the menu 'Disconnect Server' to 'Disconnect from server'.
  * Added capability to deploy PostgreSQL servers on Amazon RDS.
  * Rename the menu 'Disconnect Database' to 'Disconnect from database'.
  * Added transaction start time to Server activity sessions view.
  * Added support for unique keys in ERD.
  * Added status bar to the Query Tool.
  * Ensure that row numbers should be visible in view when scrolling
    horizontally.
  * Relocate GIS Viewer Button to the Left Side of the Results Table.
  * Added capability to deploy PostgreSQL servers on EDB BigAnimal.
  * Added options 'Ignore owner' and 'Ignore whitespace' to the schema diff
    panel.
  * Added support for Azure AD OAUTH2 authentication.
  * Ensure the database and schema restriction controls are not shown as a
    drop-down.
  * Added the ability to resize columns on dashboard tables.
  * PG 15 compatibility issues fixed.
  * Added capability to deploy PostgreSQL servers on Microsoft Azure.
  * Added support for visualise the graph using a Line chart in the query tool.
  * Added option to trigger autocomplete on key press in the query tool.
  * Allow users to delete files/folders from the storage manager.
  * Allow users to search within the file/storage manager.
  * Added support for visualizing the graphs using Stacked Line, Bar, and
    Stacked Bar charts in the query tool.
  * Added support for visualise the graph using a Pie chart in the query tool.
  * Removing dynamic module loading and replacing it with static loading.
  * Added support to show all background processes in separate panel.
  * Added support to create triggers from existing trigger functions in EPAS.
  * Remove the SQL files for the unsupported versions of the database server.
  * Fixed improper parsing of HTTP requests in Pallets Werkzeug v2.1.0
    and below (CVE-2022-29361).
- Drop patches remove_simplejson_dep.patch, fix-python-lib.patch and
  0001-Fix-bug-ValueError-unsupported-format-character-D.patch
- Add patch support-new-werkzeug.patch and support-new-azure-mgmt-rdbms.patch:
  * Support changes among our dependencies.
* Sat Feb 11 2023 Matej Cepl <mcepl@suse.com>
- Remove dependency on python-simplejson
  (gh#pgadmin-org/pgadmin4#5853).
* Wed Jun  9 2021 Ralf Habacker <ralf.habacker@freenet.de>
- Add 0001-Fix-bug-ValueError-unsupported-format-character-D.patch
  to fix bug reported at https://redmine.postgresql.org/issues/6522
* Tue Feb  2 2021 Antonio Larrosa <alarrosa@suse.com>
- Fix typos (chmod being used instead of chown in %%postun web and
  pgadmin4 used in the service file for User/Group keys instead of
  pgadmin)
* Mon Feb  1 2021 Marcus Rueckert <mrueckert@suse.de>
- the system wide service does not need to run as root. switch to
  user/group pgadmin
* Sat Jan 30 2021 Marcus Rueckert <mrueckert@suse.de>
- Update to 4.30
  - Features:
  - ERD Tool (Beta): The Entity-Relationship Diagram (ERD) tool
    is a database design tool that provides a graphical
    representation of database tables, columns, and
    inter-relationships. You can use the ERD tool to design a new
    schema and generate the SQL required to create it, or to
    reverse engineer and diagram an existing database schema.
  - Kerberos support is added in pgAdmin 4 using SPNEGO for
    logging into pgAdmin, similar to the existing LDAP and
    "internal" options. Note that support for logging into
    database servers using Kerberos is not included in this
    release, but will be added in a future version.
  - Add a container option (PGADMIN_DISABLE_POSTFIX) to disable
    the Postfix server: Postfix (like other MTAs) must start as
    user 'root', and the pgAdmin container achieves this using
    'sudo'. Whilst that works well in most environments, it can
    cause problems in some. This option allows you to completely
    disable Postfix to avoid these issues, though you will need
    to configure an external mail server to be used to send
    password reset emails.
  - Bugs/Housekeeping:
  - Improve the explain plan details by showing a popup instead
    of a tooltip when clicking on plan nodes.
  - Ensure that verbose logs are visible for Utility (Backup,
    Maintenance etc.) jobs.
  - Added support for expressions in exclusion constraints.
  - Ensure that the 'template1' database is not visible after
    pg_upgrade.
  - Added appropriate help message and a placeholder for letting
    users know about the account password expiry for Login/Group
    Role.
  - Updated Flask-BabelEx to the latest version.
  - Fixed extra parentheses issue around joins for Views.
  - Ensure that the current value of sequences is ignored while
    comparing using Schema Diff.
  - Fixed an issue when the user tries to delete multiple records
    in the data grid.
  - Fixed TypeError exception in schema diff when selecting two
    identical objects.
  - Include PostgreSQL 13 utilities in the container
    distribution.
  https://www.pgadmin.org/docs/pgadmin4/4.30/release_notes_4_30.html
* Wed Jan 27 2021 Antonio Larrosa <alarrosa@suse.com>
- Fix the desktop application by removing the overriding of
  SERVER_MODE in config_system.py and config_distro.py which were
  forcing SERVER_MODE to always have a specific value instead
  of letting the runtime choose so there's no need to force it.
- Rename pgadmin4.conf to pgadmin4.conf.in,
  pgadmin4.uwsgi to pgadmin4.uwsgi.in and
  README.SUSE.uwsgi to README.SUSE.uwsgi.in and make them also
  replace PYTHONSITELIB  with the python version used at build time
- Replace all variables from config files in %%prep instead of
  %%install
- Include README.SUSE.uwsgi in the web-uwsgi subpackage
* Wed Jan 27 2021 Antonio Larrosa <alarrosa@suse.com>
- Add BuildRequires for python-cryptography and replace dependency for
  python-Flask-Babel with python-Flask-BabelEx
* Fri Dec 11 2020 Andreas Schneider <asn@cryptomilk.org>
- Add BuildRequires for python modules
* Fri Dec 11 2020 ecsos <ecsos@opensuse.org>
- Update to 4.29:
  - Ensure that folder rename should work properly in Storage
    Manager
  - Fixed an issue where the debugger's custom tab title not
    applied when opened in the new browser tab
  - Fixed an issue where dynamic tab title has not applied the
    first time for debugger panel
  - Fixed an issue where schema diff doesn't show the result of
    compare if source schema has tables with RLS
  - Fixed an issue where the process watcher dialog throws an error
    for the database server which is already removed
  - Ensure that code coverage should cover class and function
    declarations
  - Ensure that dirty indicator (*) should not be visible when
    renaming the tabs
  - Fixed an issue where shared servers import is failing
  - Improve code coverage and API test cases for Foreign Tables,
    Debugger, Views and Materialized Views
- Fix some requirement versions.
* Wed Nov 18 2020 Marcus Rueckert <mrueckert@suse.de>
- Update to 4.28:
  - Added support to download utility files at the client-side.
  - Added support to rename query tool and debugger tabs title.
  - Added support for dynamic tab size.
  - Added tab title placeholder for Query Tool, View/Edit Data, and
    Debugger.
  - Added support to compare schemas and databases in schema diff.
  - Ensure that non-superuser should be able to debug the function.
  - Ensure that query history should be listed by date/time in
    descending order.
  - Ensure that Grant Wizard should include foreign tables.
  - Ensure that search object functionality works with case
    insensitive string.
* Sat Oct 17 2020 ecsos <ecsos@opensuse.org>
- Update to 4.27:
  - Added Macro support.
  - Added support to view trigger function under the respective
    trigger node.
  - Allow user to change the database connection from an open query
    tool tab.
  - Added support to ignore the owner while comparing objects in
    the Schema Diff tool.
  - Merged the latest code of 'pgcli' used for the autocomplete
    feature.
  - Fixed invalid literal issue when fetching dependencies for
    Materialized View.
  - Fixed an issue where schema diff is showing identical table as
    different due to default vacuum settings.
  - Ensure that the user should be able to change the start value
    of the existing sequence.
  - Fixed an issue where the query tool is not fetching more than
    1000 rows for the table does not have any primary key.
  - Fixed an issue where 'Rows X' column values were not visible
    properly for Explain Analyze in Dark theme.
  - Fixed an issue where file extension is stripped on renaming a
    file.
* Mon Sep 21 2020 Andreas Schneider <asn@cryptomilk.org>
- Specify path for pg_dump and pg_restore
- Disable update check (if you're on leap or other you wont be able
  to upgrade to a newer version anyway)
* Sun Sep 20 2020 Marcus Rueckert <mrueckert@suse.de>
- Update to 4.26:
  - Added SQL Formatter support in Query Tool.
  - Added a new button to the query tool toolbar to open a new
    query tool window.
  - Added shared server support for admin users.
  - Warn the user when connecting to a server that is older than
    pgAdmin supports.
  - Ensure that schema names starting with 'pg' should be visible
    in browser tree when standard_conforming_strings is set to off.
  - Fixed an issue where --load-server does not allow loading
    connections that use pg_services.
  - Fixed string indices must be integers issue for PostgreSQL <
    9.3.
  - Fixed an issue where the application ignores the fixed port
    configuration value.
  - Remove illegal argument from trigger function in trigger DDL
    statement.
  - Ensure that 'setup-web.sh' should work in Debian 10.
  - Fixed excessive CPU usage by stopping the indefinite growth of
    the graph dataset.
* Fri Sep 11 2020 Andreas Schneider <asn@cryptomilk.org>
- Create a pgadmin user and group
- Add uwsgi configuration (fast, user privileges and apparmor support)
* Thu Sep 10 2020 Andreas Schneider <asn@cryptomilk.org>
- Only activate the pgadmin4 apache config if the PGADMIN4 flag is set.
  For mod_wsgi you should use `a2enmod wsgi`
- Create /etc/pgadmin/config_system.py with server mode for web
  Run /usr/lib/python3.6/site-packages/pgadmin4-web/setup.py to create
  the admin user
- Remove config_local.py with outdated options
* Mon Sep  7 2020 Paolo Stivanin <info@paolostivanin.com>
- Update to 4.25:
  - Modified schema diff tool to compare two databases instead of
    two schemas
  - Resolve schema diff dependencies by selecting the appropriate
    node automatically and maintain the order in the
    generated script.
  - Replace charting library Flotr2 with ChartJS using React.
  - Upgrade font-awesome from v4 to v5.
  - Fixed an issue where debugger doesn't work if the search path
    is set other than 'public'.
  - Fixed ssh tunnel hang issue when the user tries to disconnect
    the server.
  - Fixed an issue where conversion of bytea to the binary string
    results in an error.
  - Fixed an issue where the entire logs are in red text when the
    user runs backup and restore.
  - Ensure that the user will be able to modify the start value
    of the Identity column.
  - Fixed an issue where 'ALTER VIEW' statement is missing when
    the user sets the default value of a column for View.
* Tue Aug  4 2020 Marcus Rueckert <mrueckert@suse.de>
- Update to 4.24
  - New features
  - Issue #5235 - Support configuration files that are external
    to the application installation.
  - Issue #5484 - Added support for LDAP authentication with
    different DN by setting the dedicated user for the LDAP
    connection.
  - Issue #5583 - Added support for schema level restriction.
  - Issue #5601 - Added RLS Policy support in Schema Diff.
  - Issue #5622 - Added support for permissive/restricted policy
    type while creating RLS Policy.
  - Issue #5650 - Added support for LDAP anonymous binding.
  - Issue #5653 - Added High Contrast theme support.
  - Housekeeping
  - Issue #5323 - Improve code coverage and API test cases for
    Foreign Data Wrapper.
  - Issue #5326 - Improve code coverage and API test cases for
    Domain and Domain Constraints.
  - Issue #5329 - Improve code coverage and API test cases for
    FTS Configuration, FTS Parser, FTS Dictionaries, and FTS
    Template.
  - Bug fixes
  - Issue #3814 - Fixed issue of error message not getting
    displayed when filename is empty for backup, restore, and
    import/export.
  - Issue #3851 - Add proper indentation to the code while
    generating functions, procedures, and trigger functions.
  - Issue #4235 - Fixed tab indent issue on a selection of lines
    is deleting the content when ‘use spaces == true’ in the
    preferences.
  - Issue #5137 - Fixed save button enable issue when focusing in
    and out of numeric input field.
  - Issue #5287 - Fixed dark theme-related CSS and modify the
    color codes.
  - Issue #5414 - Use QStandardPaths::AppLocalDataLocation in the
    runtime to determine where to store runtime logs.
  - Issue #5463 - Fixed an issue where CSV download quotes
    numeric columns.
  - Issue #5470 - Fixed backgrid row hover issue where on hover
    background color is set for edit and delete cell only.
  - Issue #5530 - Ensure that the referenced table should be
    displayed on foreign key constraints.
  - Issue #5554 - Replace the runtime themes with ones that don’t
    have sizing issues.
  - Issue #5569 - Fixed reverse engineered SQL for partitions
    when storage parameters are specified.
  - Issue #5577 - Include LICENSE and DEPENDENCIES [inventory]
    files in official packages.
  - Issue #5621 - Remove extra brackets from reverse engineering
    SQL of RLS Policy.
  - Issue #5629 - Fixed an issue where the user is able to edit
    properties when some of the collection nodes are selected.
  - Issue #5630 - Fixed an issue where installation of pgadmin4
    not working on 32-bit Windows.
  - Issue #5631 - Fixed ‘cant execute empty query’ issue when
    remove the value of ‘USING’ or ‘WITH CHECK’ option of RLS
    Policy.
  - Issue #5633 - Ensure that create RLS Policy menu should not
    be visible for catalog objects.
  - Issue #5647 - Fixed an issue where difference DDL is showing
    the wrong SQL when changing the policy owner.
  - Issue #5662 - Fixed accessibility issue where few dialogs are
    not rendering properly when we zoomed in browser window 200%%
    and screen resolution is low.
  - Issue #5666 - Added missing dependencies/dependent and
    corrected some wrongly identified.
  - Issue #5673 - Fixed an issue where fetching the schema throws
    an error if the database is not connected in Schema Diff.
  - Issue #5675 - Fixed CSRF errors when pgAdmin opened in an
    iframe on safari browser.
  - Issue #5677 - Fixed text color issue in explain analyze for
    the Dark theme.
  - Issue #5686 - Fixed issue where the user was not able to
    update policy if the policy is created with space.
- update requires to match requirements.txt
* Tue Jul 14 2020 Marcus Rueckert <mrueckert@suse.de>
- Update to 4.23
  - New features
  - Issue #5468 - Added option to ignore the whitespaces while
    comparing objects in schema diff.
  - Issue #5500 - Added server group name while selecting servers
    in schema diff.
  - Issue #5516 - Added support of Row Security Policies.
  - Issue #5576 - Improve error messaging if the storage and log
    directories cannot be created.
  - Housekeeping
  - Issue #5325 - Improve code coverage and API test cases for
    Collations.
  - Issue #5574 - Cleanup Windows build scripts and ensure
    Windows x64 builds will work.
  - Issue #5581 - Documentation of Row Level Security Policies.
  - Bug fixes
  - Issue #3591 - Ensure that the query tool should display the
    proper error message while terminating the active session.
  - Issue #3669 - Ensure that proper error should be displayed
    for the deleted node.
  - Issue #3787 - Disabled the Stop process button after clicking
    it and added a message ‘Terminating the process…’ to notify
    the user.
  - Issue #4226 - Fixed an issue where select all checkbox only
    selects the first 50 tables.
  - Issue #5416 - Ensure that the query tool panel gets closed
    when clicking on the ‘Don’t Save’ button.
  - Issue #5465 - Fixed an issue where the Edge browser version
    is showing wrong and warning message gets displayed.
  - Issue #5492 - Fixed an issue where the search object is
    unable to locate inherited tables and constraint filters are
    not working.
  - Issue #5507 - Fixed connection and version number detection
    issue when the database server is upgraded.
  - Issue #5521 - Fixed an issue when dumping servers from a
    desktop pgAdmin app by providing an option ‘–sqlite-path’.
  - Issue #5539 - Fixed typo in exception keyword.
  - Issue #5584 - Fixed an issue where two identical tables
    showing different by schema diff tool.
  - Issue #5592 - Ensure that pgadmin should be able to connect
    to the server which has password more than 1000 characters.
* Mon Jun 15 2020 Michal Vyskocil <mvyskocil@opensuse.org>
- Update to 4.22
  - New features
  * Added connected pgAdmin user and connection name in the log file.
  * Show the startup log as well as the server log in the runtime's log
    viewer.
  - Bugfixes
  * Gracefully informed the user that the database is already connected when
  they click on "Connect Database...".
  * Fixed an issue where clicking on the cross button of the alert box on
  the login page is not working.
  * Fixed the SQL help issue for EDB Postgres Advanced Server.
  * Ensure that maintenance job should be worked properly for indexes under
  a materialized view.
  * Ensure that file browse "home" button should point to $HOME rather than /.
  * Ensure that 'With OID' option should be disabled while taking backup of
  database server version 12 and above.
  * Fixed invalid literal issue when removing the connection limit for the
  existing role.
  * Fixed internal server error when clicking on Triggers -> 'Enable All'
  for partitions.
  * Fixed generated SQL issue for auto vacuum options.
  * Ensure that the dependencies tab shows correct information for Synonyms.
  * Fixed an issue where the newly added table is not alphabetically added
  to the tree.
  * Fixed list sorting issue in the schema diff tool.
  * Fixed an issue while comparing the two identical schemas using the
  schema diff tool.
  * Fixed an issue when renaming the column not added in the proper order.
  * Correct ipv4 "all interfaces" address in the container docs, per Frank
  Limpert.
  * Fixed an issue where select2 hover is inconsistent for the SSL field in
  create server dialog.
  * Fixed post-login redirect location when running in server mode under a
  non-default root.
  * Fixed an issue where the background job creation fails if there is only
  a version-specific python binary available in PATH.
  * Fixed data truncation issue when updating the data of type character
    with length.
  * Fixed an issue where if LDAP_SEARCH_BASE_DN is not set then, the value
    for LDAP_BASE_DN will be considered.
  * Fixed an issue where clicking on Select All button, not selecting all
    the options in pgAgent job scheduler.
  * Clarify and correct the docs on enabling the pl/debugger plugin on the
    server.
  * Fixed Unicode decode error 'utf-8' codec can't decode byte.
- Packaging:
  * refresh fix-python-lib.patch
  * add keyring e8697e2eef76c02d3a6332778881b2a8210976f2 enabling
    GPG source tarballs verification
* Thu May 14 2020 Antonio Larrosa <alarrosa@suse.com>
- Decrease requirements to build in SLE/Leap:
  * Werkzeug from 0.15.0 to 0.14.1
  * passlib from 1.7.2 to 1.7.1
  * psycopg from 2.8 to 2.7.4
  * python-dateutil from 2.8.0 to 2.7.3
  * simplejson from 3.16.0 to 3.13.2
  * pytz from 2018.9 to 2018.3
  pgadmin has this tendency to just follow the latest versions
  instead of properly specify required versions.
* Wed May 13 2020 Antonio Larrosa <alarrosa@suse.com>
- Update to 4.21
  - New features
  * Added search object functionality.
  * Added LDAP authentication support.
  * Added support for parameter toast_tuple_target and parallel_workers
    of the table.
  * Added support of Packages, Sequences and Synonyms to the
    Schema Diff.
  * Added an option to prevent a browser tab being opened at startup.
  - Bug fixes
  * Ensure that the start and end date should be deleted when clear
    the selection for pgAgent Job.
  * Fixed calendar opening issue on the exception tab inside the
    schedules tab of pgAgent.
  * Fixed an issue where the autovacuum_enabled parameter is added
    automatically in the RE-SQL when the table has been created
    using the WITH clause.
  * Fixed generated SQL when any token in FTS Configuration or any
    option in FTS Dictionary is changed.
  * Fixed tab key navigation issue for parameters in table dialog.
  * Ensure that switch cell is in sync with switch control for
    accessibility.
  * Fixed compilation warnings while building pgAdmin.
- Update to 4.20
  - New features
  * Added support of Collation, FTS Configuration, FTS Dictionary,
    FTS Parser and FTS Template to the Schema Diff.
  * Added support of Domain, Domain Constraints and Types to the
    Schema Diff.
  - Housekeeping
  * Enhance the color of switch control for both light and dark theme.
  * Added and fixed gettext usage for better translation coverage.
  - Bug fixes
  * Fix an issue where the user can not change the value of DateTime
    picker control using keyboard.
  * Fixed some accessibility issues in the dialogs.
  * Fixed chrome driver download utility issue for Ubuntu.
  * Change some colors and opacity to comply with WCAG color
    contrast standards.
  * Fix an accessibility issue to maximize the panel for all
    alertify dialog.
  * Improve logic to get the DDL statements as a part of the
    comparison.
  * Fixed tab key navigation issue for Grant Wizard.
  * Fixed Unicode character issue causing error on Python2 environment.
  * Fixed focus color issue for Alertify dialog buttons.
* Tue Mar 24 2020 Antonio Larrosa <alarrosa@suse.com>
- Update dependencies versions and replace python-Flask-Security
  with python-Flask-Security-Too (fixes boo#1166991)
* Mon Mar 16 2020 Antonio Larrosa <alarrosa@suse.com>
- Update to 4.19 (boo#1166681)
  - New features
  * Added accessibility support in AlertifyJS.
  * Added Czech language support.
  * Added Python 3.8 support.
  - Housekeeping
  * Improve code coverage and API test cases for the Event Trigger module.
  * Improvements in the UI for both default and dark themes.
  * Enhance logging by tracking stdout and stderr of subprocess when
    log level set to DEBUG.
  * Added option to override the class name of a label tag for select2
    control.
  - Bug fixes
  * Changed the color of selected and hovered item for Select2 dropdown.
  * Improve the style of the highlighted code after query execution for
    Dark mode.
  * Ensure that AlertifyJS should not be visible as a title for alert
    dialog.
  * Changed background pattern for geometry viewer to use #fff for all
    themes.
  * Fix an issue where debugger not showing all arguments anymore after
    hitting SQL error while debugging.
  * Set proper focus on tab navigation for file manager dialog.
  * Fix an issue where command and statements were parsed incorrectly
    for Rules.
  * Ensure that all the transactions should be canceled before closing
    the connections when a server is disconnected using pgAdmin.
  * Fixed Firefox monospaced issue by updating the font to the latest
    version.
  * Update Flask-SQLAlchemy and SQLAlchemy package which is not working
    on Windows with Python 3.8.
  * Fix syntax error when changing the event type for the existing rule.
- Update to 4.18
  - New features
  * Added support for a multi-level partitioned table.
  * Added a Schema Diff tool to compare two schemas and generate a diff
    script.
  * Allow screen-reader to read label & description of non-textable
    elements.
  * Allow screen-reader to identify the alert errors.
  * Added labels and titles after parsing and validating all the pgAdmin4
    web pages for accessibility.
  * Set input controls as read-only instead of disabled will allow tab
    navigation in the properties tab and also allow screen readers to
    read it.
  - Housekeeping
  * Improve code coverage and API test cases for the CAST module.
  * Improve code coverage and API test cases for the LANGUAGE module.
  * Improve the test framework to run for multiple classes defined in a
    single file.
  * Updated wcDocker package which includes aria-label accessibility
    improvements.
  * Replace node-sass with sass for SCSS compilation.
  - Bug fixes
  * Ensure that path file name should not disappear when changing ext from
    the dropdown in file explorer dialog.
  * Fixed an issue while editing char[] or character varying[] column from
    View/Edit data throwing an error.
  * Fixed an issue where Grant wizard unable to handle multiple objects when
    the query string parameter exceeds its limit.
  * Added tab navigation on close buttons for all the panels and
    create/properties dialog.
  * Fix column resizable issue in the file explorer dialog.
  * Logout the pgAdmin session when no user activity of mouse move, click
    or keypress.
  * Fix an issue where setting STORAGE_DIR to empty should show all
    the volumes on Windows in server mode.
  * Updated the incorrect icon used for the cast node on refresh.
  * Fix an issue where refreshing a package results in the change in
    the object completely.
  * Fix an issue where select, insert and update scripts on tables throwing
    an error.
  * Ensure Postfix starts in the container, now it runs as non-root
    by default.
  * Fixed an issue where Save Password control disappears after clicking
    on it while creating a server.
- Update to 4.17
  - New features
  * Allow screen-reader to read relationship attributes in nested elements.
  * Ensure all binaries are securely signed and linked with the hardened
    runtime in the macOS bundle
  - Housekeeping
  * Refactored SQL of Table’s and it’s child nodes.
  * Refactored SQL of Views and Materialized Views.
  * Refactored SQL of Functions and Procedures.
  * Added support for on-demand loading of items in Select2.
  * Added code coverage tool for pgAdmin.
  - Bug fixes
  * Fix syntax highlighting in code mirror for backslash and escape constant.
  * Fix an issue where clicking on an empty textbox like fill factor or
    comments, considers it as change and enabled the save button.
  * Added support to view multilevel partitioned tables.
  * Ensure that constraints, indexes, rules, triggers, and compound triggers
    should be created on partitions.
  * Added more information to the ‘Database connected/disconnected’ message.
  * Ensure that the user should be able to select/modify tablespace for the
    partitioned table on v12 and above.
  * Rename some internal environment variables that could conflict with
    Kubernetes.
  * Fix vulnerability issues reported by ‘yarn audit’. Replace the
    deprecated uglifyjs-webpack-plugin with a terser-webpack-plugin.
  * Ensure that the error message should not be displayed if Tablespace is
    not selected while creating the index.
  * Fix an issue where operator, access method and operator class is
    not visible for exclusion constraints.
  * Add a note to the documentation about the use of non-privileged ports
    on filesystems that don’t support extended attributes when running
    the container.
  * Added tab navigation for tabs under explain panel in query tool.
  * Fix an issue where the table is not created with autovacuum_enabled
    and toast.autovacuum_enabled for PG/EPAS 12.
- Update to 4.16
  - New features
  * Warn the user on changing the definition of Materialized View about
    the loss of data and its dependent objects.
  * Allow drag and drop functionality for all the nodes under the database
    node, excluding collection nodes.
  * Use a ‘play’ icon for the Execute Query button in the Query Tool for
    greater consistency with other applications.
  * Added aria-label to provide an invisible label where a visible label
    cannot be used.
  * Added role=”status” attribute to all the status messages for
    accessibility.
  * Run pgAdmin in the container as a non-root user (pgadmin, UID: 5050)
  * Allow Gunicorn logs in the container to be directed to a file specified
    through GUNICORN_ACCESS_LOGFILE.
  * Changed the open query tool and data filter icons.
  - Housekeeping
  * Add Reverse Engineered and Modified SQL tests for Materialized Views.
  * Refactored code of table and it’s child nodes.
  * Refactored code of columns node.
  - Bug fixes
  * Fix issue where the Reset button does not get enabled till all
    the mandatory fields are provided in the dialog.
  * Fix scrolling issue in ‘Users’ dialog.
  * Remove the sorting of table headers with no labels.
  * Updated documentation for default privileges to clarify more on the
    grantor.
  * Fix query tool launch error if user name contains HTML characters.
    It’s a regression.
  * Fix network disconnect issue while establishing the connection via
    SSH Tunnel and it impossible to expand the Servers node.
  * Fix an issue where the wrong type is displayed when changing the
    datatype from timestamp with time zone to timestamp without time zone.
  * Ensure that the superuser should be able to create database, as the
    superuser overrides all the access restrictions.
  * Fix server connection drops out issue in query tool.
  * Updated the json file name from ‘servers.json’ to
    ‘pgadmin4/servers.json’ in the container deployment section of
    the documentation.
  * Ensure that the superuser should be able to create role, as the
    superuser overrides all the access restrictions.
  * Fix reverse engineering SQL issue for partitions when specifying
    digits as comments.
  * Enhance the logic to change the label from ‘Delete/Drop’ to
    ‘Remove’ for the server and server group node.
  * Shown some text on process watcher till the initial logs are loaded.
  * Fix VPN network disconnect issue where pgAdmin4 hangs on expanding
    the Servers node.
  * Fix main window tab navigation accessibility issue.
  * Ensure that the Servers collection node should expand independently
    of server connections.
  * Fix the help button link on the User Management dialog.
  * Fix accessibility issues.
  * Fix XSS issue in explain and explain analyze for table and type which
    contain HTML.
  * Fix an issue of retrieving properties for Compound Triggers.
    It’s a regression.
  * Fix an issue where pgAdmin4 unable to retrieve table node if the
    trigger is already disabled and the user clicks on Enable All.
  * Fix reverse engineering SQL issue for triggers when passed a single
    argument to trigger function.
  * Fix an issue where length and precision are not removed from
    table/column dialog.
  * Fix an issue where the Interval data type is not displayed in the
    properties dialog of table/column.
  * Fix ‘Could not find the object on the server.’ error while
    refreshing the check constraint.
  * Fix issue where the user can not switch the UI language. It’s a
    regression.
  * Fix reverse engineering SQL issue where when clause is not visible
    for PG/EPAS 12.
  * Fix pgAdmin4 failed to start issue after upgrading to version 4.15.
  * Added statistics and storage information in reverse engineering SQL
    of table/column.
  * Fix an issue where the inherited table name with quotes did not escape
    correctly.
  * Fix an issue where context menu is open along with submenu and
    the focus is not on context menu or submenu.
- Update to 4.15
  - New features
  * Added encrypted password in reverse engineered SQL for roles.
  * Added Dark(Beta) UI Theme option.
  * Support Enable Always and Enable Replica on triggers.
  * Add an option to request confirmation before cancelling/resetting
    changes on a Properties dialog.
  * Added support for custom theme creation and selection.
  - Bug fixes
  * Ensure create new object dialog should be opened when alt+shift+n key
    is pressed on the collection node.
  * Fixed issue where Drop and Disconnect connection menu points are
    too close to each other.
  * Ensure context menus never get hidden below the menu bar.
  * Rename the context menu from ‘Drop Server’ to ‘Remove Server’.
  * Ensure the correct “running at” agent is shown when a pgAgent job
    is executing.
  * Fix an issue in the Query Tool where shortcut keys could be ignored
    following a query error.
  * Fix the toggle case shortcut key combination.
  * Fix an issue where a black arrow-kind image is displaying at the
    background of browser tree images.
  * Ensure comments are shown in reverse engineered SQL for table
    partitions.
  * Handle NULL values appropriately when sorting backgrid tables.
  * Give appropriate error messages when the user tries to use an
    blank master password.
  * Remove arbitrary (and incorrect) requirement that composite types
    must have at least two members.
  * Don’t quote bigints when copying them from the Query Tool results
    grid.
  * Ensure compression level is passed to pg_dump when backing up in
    directory format.
  * Ensure the number of jobs can be specified when backing up in
    directory format.
  * Ensure Javascript errors during Query Tool execution are reported
    as such and not as Ajax errors.
  * Suppress Enter key presses in Alertify dialogues when the come from
    Select2 controls to allow item selection with Enter.
  * Ensure that units are respected when sorting by file size in the
    File dialog.
  * Ensure all messages are retained in the Query Tool from long running
    queries.
  * Updated documentation for the delete row button that only strikeout
    the row instead of deleting it.
  * Updated documentation for the query tool toolbar buttons.
  * Fixed an issue where psql of v12 throwing “symbol not found” error
    while running Maintenance and Import/Export.
  * Fixed potential error in the properties dialog for the Code tab.
  * Fixed an issue where Datetimepicker control opens when clicking on
    the label.
  * Fixed potential issue in reset function for nested objects.
  * Fixed an issue where escape key not working to close the open/save
    file dialog.
  * Fixed an issue where keyboard shortcut for context menu is not working
    when using Firefox on CentOS7.
  * Fixed docker container exit issue occurs due to change in Gunicorn’s
    latest version.
- Rebase patches:
  * use-os-makedirs.patch
- Add patch to fix command to link to the python library
  * fix-python-lib.patch
* Wed Oct 23 2019 Marcus Rueckert <mrueckert@suse.de>
- refresh use-os-makedirs.patch to apply cleanly again
* Wed Oct 23 2019 Marcus Rueckert <mrueckert@suse.de>
- add back defattr to fix sle12 build
* Mon Oct 21 2019 ecsos@opensuse.org
- Update to 4.14
  - New features
  * Added Copy with headers functionality when copy data from
    Query Tool/View Data.
  * Implemeted the Query Plan Analyser.
  * Include PostgreSQL 12 binaries in the container.
  - Housekeeping
  * Add Reverse Engineered and Modified SQL tests for Synonyms.
  * Add Reverse Engineered and Modified SQL tests for Unique
    Constraints.
- Optimize Webpack to improve overall performance.
  - Bug fixes
  * Ensure backup a partition table should not backup the whole
    database.
  * Ensure that ‘ENTER’ key in the data filter should not run the
    query.
  * Fix issue where backup fails for schema name that needs
    quoting.
  * Highlighted the color of closing or opening parenthesis when
    user select them in CodeMirror.
  * Fix issue where export job fails when deselecting all the
    columns.
  * Fix an error where ‘false’ string is displayed when we add
    a new parameter in the Parameters tab, also clear the old
    value when the user changes the parameter name.
  * Ensure that pgAdmin should work behind reverse proxy if the
    inbuilt server is used as it is.
  * Fix issue where pgAdmin does not load completely if loaded in
    an iframe.
  * Ensure the search path should not be quoted for Database.
  * Ensure pgAdmin should work behind reverse proxy on a non
    standard port.
  * Fix query tool open issue on Internet Explorer.
  * Fix issue where query history is not visible in the query
    history tab.
  * Ensure the search path should not be quoted for Function,
    Procedure and Trigger Function.
  * Fix issue where VALID foreign keys show as NOT VALID in the
    SQL tab for tables.
  * Ensure the MAC OSX app should be notarized for Catalina.
- Changes from 4.13
  - New features
  * Added Gather Merge, Named Tuple Store Scan and Table Function
    Scan icon for explain module.
  * Don’t wait for the database connection before rendering the
    Query Tool UI, for improved UX.
  * Allow configuration options to be set from the environment in
    the container distribution.
  * Ensure editable and read-only columns in Query Tool should be
    identified by icons and tooltips in the column header.
  * Add an Italian translation.
  * Refactor Dockerfile to avoid needing to run supporting
    scripts (i.e. ‘docker build .’ will work) and minimise layers.
  - Housekeeping
  * Add Reverse Engineered SQL tests for Schemas.
  * Add Reverse Engineered SQL tests for Views.
  * Add Reverse Engineered SQL tests for Rules.
  * Add Reverse Engineered and Modified SQL tests for Foreign Keys.
  * Add Reverse Engineered and Modified SQL tests for Foreign Servers.
  * Add Reverse Engineered and Modified SQL tests for Foreign Tables.
  * Add Reverse Engineered and Modified SQL tests for FTS Templates.
  * Add Reverse Engineered and Modified SQL tests for Indexes.
  * Add Reverse Engineered and Modified SQL tests for Primary Keys.
  * Add Reverse Engineered and Modified SQL tests for User Mappings.
  * Add Modified SQL tests for Resource Group.
  - Bug fixes
  * Added ProjectSet icon for explain module.
  * Ensure Boolean columns should be editable using keyboard keys.
  * Further code refactoring to stabilise the Feature Tests.
  * Fix an issue where oid column should not be pasted when
    copy/paste row is used on query output containing the oid
    column.
  * Fix display of validation error message in SlickGrid cells.
  * Fix issue where Validated switch option is inverted for the
    Foreign Key.
  * Fix a debugger error when using Python 2.7.
  * Fix error while importing data to a table using Import/Export
    dialog and providing “Not null columns” option.
  * Ensure View should be created with special characters.
  * Ensure Boolean columns should be editable in View/Edit data
    and Query Tool.
  * Fix an error that could be seen when click on any system
    column of a table.
  * Unescape HTML entities in database names in the Query Tool
    title bar.
  * Add editor options for plain text mode and to disable block
    folding to workaround rendering speed issues in CodeMirror
    with very large scripts.
  * Ensure port and username should not be mandatory when
    a service is provided.
  * Fix Truncate option deselect issue for compound triggers.
  * Fix length and precision enable/disable issue when changing
    the data type for Domain node.
  * Fix SQL tab issue for Views. It’s a regression of compound
    triggers.
  * Fix PGADMIN_SERVER_JSON_FILE environment variable support in
    the container.
  * Fix exception in query history for python 2.7.
  * Fix query tool launch error if user name contain html
    characters.
  * Increase cache control max age for static files to improve
    performance over longer run.
  * Fix SQL issue of length and precision when changing the data
    type of Column.
  * Fix modified SQL for Index when reset the value of Fill
    factor and Clustered?.
  * Fix reversed engineered SQL for btree Index when provided
    sort order and NULLs.
  * Ensure sequence with negative value should be created.
  * Fix issue where EXEC script doesn’t write the complete script
    for Procedures.
  * Fix query tool and view data issue with the Italian language.
  * Ensure Primary Key should be created with Index.
  * Fix query history exception for Python 3.6.
* Sat Sep  7 2019 ecsos@opensuse.org
- Update to 4.12
  - New features
  * Add support of Compound Triggers for EPAS 12+.
  * Add support for planner support functions in PostgreSQL 12+
    functions.
  * Add support for generated columns in Postgres 12+.
  * Use the full tab space for CodeMirror instances on dialogues
    where appropriate.
  * Allow a banner to be displayed on the login and other related
    pages showing custom text.
  * Allow enhanced cookie protection to be disabled for
    compatibility with dynamically addressed hosting environments.
  * Add an optimisation to the internal code responsible for
    searching for treeview nodes.
  * Display the row count in the popup message when counting
    table rows, not just in the properties list.
  * Add support in query history to show internal queries
    generated by pgAdmin during save data operations.
  - Housekeeping
  * Add Reverse Engineered SQL tests for Columns.
  * Add Reverse Engineered SQL tests for Trigger Functions.
  * Add Reverse Engineered SQL tests for Exclusion Constraint.
  * Add a –modules option to the RE-SQL test suite to allow
    testing of specific object types.
  - Bug fixes
  * Fix issue where Deleting N number of rows makes first N
    number of rows disable.
  * Fix generation of reverse engineered SQL for tables with
    Greenplum 5.x.
  * Update wcDocker to allow the browser’s context menu to be
    used except in tab strips and panel headers.
  * Ensure type names are properly encoded in the results grid.
  * Fix generation of reverse engineered SQL for partition table,
    partitions were shown as a child of indexes.
  * Update wcDocker to prevent window state loading creating
    blank dialogues.
  * Fix accessibility issue for checkbox in IE11.
  * Ensure the Query Tool doesn’t throw an error when viewing the
    contents of a table with no columns.
  * Ensure columns can be created when they are IDENTITY fields
    with the CYCLE option enabled.
  * Ensure purely numeric comments can be saved on new columns.
  * Fix accessibility issue for Datetime cell in backgrid.
  * Ensure the query tool will work with older versions of
    psycopg2 than we officially support, albeit without updatable
    resultsets.
  * Ensure command tags are shown in the messages tab of the
    Query Tool.
  * Fix load on demand in View/Edit data mode.
  * Fix some errors thrown on the JS console when dragging text
    in the Query Tool.
  * Ensure triggers should be updated properly for EPAS server.
  * Fix the reverse engineered SQL for trigger functions with the
    WINDOW option selected.
  * Ensure enable trigger menu should be visible when trigger is
    disabled.
  * Ensure the comment on a Primary Key constraint can be edited
    under the Table node.
  * Fix console error when changing kind(SQL/BATCH) for pgAgent
    job step.
  * Fix double click issue to expand the contents of a cell if
    the resultset was not editable.
  * Fix generation of reverse engineered SQL for Rules.
  * Ensure compound triggers for event should be updated
    properly.
  * Ensure compound triggers should be displayed under Views.
  * Ensure Truncate option should be available for Compound
    Triggers.
- Changes from 4.11
  - New features
  * Add support for editing of resultsets in the Query Tool,
    if the data can be identified as updatable.
  * Set the mouse cursor appropriately based on the layout lock
    state.
  * Add EXPLAIN options for SETTINGS and SUMMARY.
  - Housekeeping
  * Add Reverse Engineered SQL tests for Roles and Resource
    Groups.
  * Add Reverse Engineered SQL tests for FDWs.
  * Add Reverse Engineered SQL tests for Languages.
  * Add Reverse Engineered SQL tests for Extensions.
  * Add Reverse Engineered SQL tests for FTS Configurations.
  * Add Reverse Engineered SQL tests for Packages.
  * Add Reverse Engineered SQL tests for FTS Dictionaries.
  * Add Reverse Engineered SQL tests for Domains.
  * Add Reverse Engineered SQL tests for Collations.
  * Add Reverse Engineered SQL tests for Types.
  * Add Reverse Engineered SQL tests for Sequences.
  * Add Reverse Engineered SQL tests for FTS Parsers.
  * Add Reverse Engineered SQL tests for Constraints.
  - Bug fixes
  * Allow keyboard navigation of all controls on subnode grids.
  * Fix dropping of pgAgent schedules through the Job properties.
  * Prevent flickering of large tooltips on the Graphical EXPLAIN
    canvas.
  * Fix an error that could be seen when editing column
    privileges.
  * Ensure parameter values are quoted when needed when editing
    roles.
  * EXPLAIN options should be Query Tool instance-specific.
  * Fix an error while retrieving json data from the table.
  * Fix ‘malformed array literal’ error when updating a pgAgent
    job.
  * Ensure drag/drop from the treeview works as expected on
    Firefox.
  * Fix table icon issue when updating any existing field.
  * Ensure browser should not be started by Selenium when feature
    tests are excluded from a test run.
  * Use ROLE consistently when generating RE-SQL for roles,
    not USER.
  * Fix an error seen when updating a connection string in
    a pgAgent job step.
  * Fix reverse engineered sql for Foreign Data Wrapper created
    on EPAS server in redwood mode.
  * Fix some minor UI issues on IE11.
  * Fix sequence reverse engineered SQL generation with quoted
    names on PG/EPAS 10+.
  * Fix an issue where Explain and Explain Analyze are not
    working, it’s regression of #1760.
  * Fix an issue where Filter toolbar button is not working in
    view/edit data, it’s regression of keyboard navigation.
- Changes from 4.10
  - New features
  * Allow some objects to be dragged/dropped into the Query Tool
    to insert their signature into the query text.
  * Allow the path to /pgadmin4/servers.json to be overridden in
    the container distribution.
  - Bug fixes
  * Ensure the browser close confirmation is only shown when
    closing a Query Tool which is running in a separate browser
    tab.
  * Prevent an error that may occur when editing data with an
    integer primary key.
  * Fix a quoting issue that caused a blank UI to be displayed
    when running in French.
  * Ensure the version comparision should be correct for windows
    installer.
- Changes from 4.9
  - New features
  * Visually distinguish simple tables from tables that are
    inherited and from which other tables are inherited.
  - Housekeeping
  * Add a framework for testing reversed engineered SQL and
    CRUD API endpoints.
  - Bug fixes
  * Fix issue where the dependencies tab for inherited
    tables/foreign keys shows partial text.
  * Allow editing of data where a primary key column includes
    a %% sign in the value.
  * Fix issue where reverse engineered SQL was failing for
    foreign tables, if it had “=” in the options.
  * Fix keyboard navigation in “inner” tabsets such as the
    Query Tool and Debugger.
  * Ensure the correct label is used in panel headers when
    viewing filtered rows.
  * Fix issue where new column should be created with Default
    value.
  * Initial support for PostgreSQL 12.
  * Initial support for PostgreSQL 12.
  * Initial support for PostgreSQL 12.
  * Prevent the geometry viewer grabbing key presses when not in
    focus under Firefox, IE and Edge.
  * Prevent the “Please login to access this page” message
    displaying multiple times.
  * Ensure that the Return key can be used to submit the Master
    Password dialogue.
  * Ensure that browser auto-fill doesn’t cause Help pages to be
    opened unexpectedly.
  * Fix issue where SSH tunnel connection using password is
    failing, it’s regression of Master Password.
  * Fix an initialisation error when two functions with
    parameters are debugged in parallel.
  * Fix issue where property dialog of column should open
    properly for EPAS v12.
  * Capitalize the word ‘export’ used in Import/Export module.
  * Ensure strings are properly encoded in the Query History.
  * Ensure we include the CSRF token when uploading files.
  * Fix connection restoration issue when pgAdmin server is
    restarted and the page is refreshed.
  * Ensure the debugger control buttons are only enabled once
    initialisation is complete.
  * Remove additional “SETOF” included when generating CREATE
    scripts for trigger functions.
  * Fix help links for backup globals and backup server.
  * Fix an XSS issue seen in View/Edit data mode if a column name
    includes HTML.
  * Ensure Python escaping matched JS escaping and fix a
    minor XSS issue in the Query Tool that required superuser
    access to trigger.
  * Ensure that both columns and partitions can be edited at the
    same time in the table dialog.
  * Fix an XSS issue when username contains XSS vulnerable text.
* Tue Jun  4 2019 ecsos@opensuse.org
- Update to pgadmin4 4.8
  - New features
  * Feature #2653 - Allow the UI layout to be fully locked or to
    prevent docking changes.
  - Bug fixes
  * Omit the geometry viewer in the Query Tool from layout
    saving.
  * Improve the performance of explain plan by embedding the
    images only when downloading it.
  * Fix the issue of accessing the SQL for Views and Materialized
    Views. Regression of pluralisation of folder names.
* Sun Jun  2 2019 ecsos@opensuse.org
- Update to pgadmin4 4.7
  - Bug fixes
  * In server mode, update all the saved server credentials when
    user password is changed.
  * Fix the responsive layout of the main menu bar.
  * Fix syntax error when adding more than one column to the
    existing table.
  * Fix file browser path issue which occurs when client is on
    Windows and server is on Mac/Linux.
  * Added Master Password to increase the security of saved
    passwords.
  * Fix accessibility issue for menu navigation.
  * Update the UI logo.
  * Fixed CSRF security vulnerability issue, per Alvin Lindstam
  * Properly assign dropdownParent in Select2 controls.
  * Ensure popper.js is installed when needed.
  * Fixed Tab key navigation for Maintenance dialog.
  * Fix Tab key issue for Toggle switch controls and button on
    the dialog footer in Safari browser.
  * Ensure that element should get highlighted when they get
    focus on using Tab key.
  * Fixed console error when subnode control is used in panels.
  * Stop using application/x-javascript as a mime type and use
    the RFC-compliant application/javascript instead.
  * Fixed error on displaying table properties of a table
    partitioned by list having a default partition.
  * Fix handling of JSON in the Query Tool with NULL elements.
  * Fix navigation of switch cells in grids.
  * Clarify wording for the NO INHERIT option on constraints,
    per Michel Feinstein.
  * Relax the permission check on the directory containing the
    config database, as it may fail in some environments such as
    OpenShift.
  * Prevent Backgrid Password cells from losing focus if the
    browser opens an autocomplete list.
  * Fix syntax error when creating a table with a serial column.
* Tue May 21 2019 ecsos@opensuse.org
- Update to pgadmin4 4.6
  - Features
  * Feature #4165 - Depend on psycopg2-binary in the Python
    wheel, rather than psycopg2.
  - Bug fixes
  * Ensure that on clicking Delete button should not delete rows
    immediately from the database server, it should be deleted
    when Save button will be clicked.
  * Ensure that newly added row in backgrid should be visible.
  * Ensure that JSON strings as comments should be added properly
    for all the objects.
  * Fix an issue where Deleting N number of rows makes
    first N number of rows disable.
  * Added support for Default Partition.
  * Fix an issue where ‘GRANT UPDATE’ sql should be displayed
    for default sequence privileges.
  * Ensure that confirmation dialog should be popped up before
    reload of query tool or debugger if it is opened in a new
    browser tab.
  * Ensure that record should be add/edited for root partition
    table with primary keys.
  * Fixed alignment issue of columns in definition section of
    Index node.
  * Fixed ‘Location cannot be empty’ error when open Tablespace
    properties.
  * Fix an issue where the dropdown becomes misaligned/displaced.
  * Ensure the treeview shows all sequences except those used to
    implement IDENTITY columns (which can be edited as part of
    the column). Show all if Show System Objects is enabled.
  * Fixed ‘Increment value cannot be empty’ error for existing
    tables.
  * Ensure that parameters of procedures for EPAS server 10 and
    below should be set/reset properly.
  * Prevent duplicate columns being included in reverse
    engineered SQL for tables.
  * Ensure sanity of the permissions on the storage and session
    directories and the config database.
* Mon Apr 15 2019 ecsos@opensuse.org
- Update to pgadmin4 4.5
  - Bug fixes
  * Fixed ‘Change Password’ issue for SCRAM authentication.
  * Ensure that two consecutive SELECT statements should work
    properly.
  * Relabel the Save button on the datagrid text editor to avoid
    confusion with the actual Save button that updates the
    database.
  * Added recommended ESLinter checks.
  * Ensure that pgAdmin4 should work properly with psycopg2 v2.8
- Changes from pgadmin4 4.4
  Warning:
  This release includes a bug fix (Bug #3887) which will rename the
  per-user storage directories for existing users when running in
  server mode. Previously, saved SQL queries were stored under the
  STORAGE_DIR in a sub-directory named after the username part of
  the user’s email address. From this version onwards, the full
  email address is used, with the @ replaced with an underscore.
  For example, in v.4.3 with STORAGE_DIR set to /var/lib/pgadmin4
  user files may be stored in:
    /var/lib/pgadmin4/storage/username/
  With the fix, that directory will be renamed (or created for new
  users) as:
    /var/lib/pgadmin4/storage/username_example.com/
  - Features
  * Add support for reverse proxied setups with Gunicorn,
    and document Gunicorn, uWSGI & NGINX configurations.
  * Make the Query Tool history persistent across sessions.
  * Remove the large and unnecessary dependency on React
    and 87 other related libraries.
  * Add support for IDENTITY columns.
  * Add an ePub doc build target.
  - Bug fixes
  * Fix naming inconsistency for the column and FTS parser
    modules.
  * Include inherited column comments and defaults in reverse
    engineered table SQL.
  * Improve a couple of German translations.
  * Use the user’s full email address (not just the username
    part) as the basis for the storage directory name.
  * Update wcDocker to fix the issue where the Scratch Pad grows
    in size if the results panel is resized.
  * Avoid ‘bogus varno’ message from Postgres when viewing the
    SQL for a table with triggers.
  * Update all Python and JavaScript dependencies.
  * Include comment SQL for inherited columns in reverse
    engineered table SQL.
  * Make the WHEN field a CodeMirror control on the Event Trigger
    dialogue.
  * Fix the online help button on the resource group dialogue.
  * Enable the online help button on the index dialogue.
  * Handle resultsets with zero columns correctly in the Query
    Tool.
  * Include inherited columns in SELECT scripts.
  * Fix the latexpdf doc build.
  * Fix handling of numeric arrays in View/Edit Data.
  * Enlarge the grab handles for resizing dialogs etc.
  * Append the file suffix to filenames when needed in the File
    Create dialogue.
  * Ensure that Firefox prompts for a filename/location when
    downloading query results as a CSV file.
  * Change the CodeMirror active line background colour to
    $color-danger-lighter so it doesn’t conflict with the
    selection colour.
  * Fix the RE-SQL syntax for roles with a VALID UNTIL clause.
  * Prevent an empty error message being shown when “downloading”
    a CREATE script using the CSV download.
  * Overhaul the layout saving code so it includes the Query Tool
    and Debugger, and stores the layout when change events are
    detected rather than (unreliably) on exit.
  * Display errors during CSV download from the Query Tool in the
    UI rather than putting them in the CSV file.
  * Improve the German translation for Backup Server.
  * Ensure the toolbar buttons are properly reset following
    a CSV download in the Query Tool.
  * Fix SQL help for EPAS 10+, and refactor the URL generation
    code into a testable function.
  * Ensure sequences can be created with increment, start,
    minimum and maximum options set.
  * Fix an issue where JSON data would not be rendered in the
    Query Tool.
  * Ensure View/Materialized View node should be visible after
    updating any property.
  * Fix custom autovacuum configuration for Materialized Views.
* Thu Mar  7 2019 ecsos@opensuse.org
- Update to pgadmin4 4.3
  - Features
  * Install a script to start pgAdmin (pgadmin4) from the command
    line when installed from the Python wheel.
  * Add a “scratch pad” to the Query Tool to hold text snippets
    whilst editing.
  * Add Commit and Rollback buttons to the Query Tool.
  * Allow X-FRAME-OPTIONS to be set for security. Default to
    SAMEORIGIN.
  * Automatically expand child nodes as well as the selected node
    on the treeview if there is only one.
  * Include multiple versions of the PG utilties in containers.
  * Update Alpine Linux version in the docker container.
  * Support double-click on Query Tool result grid column resize
    handles to auto-size to the content.
  - Bug fixes
  * Ensure size stats are prettified on the statistics tab when
    the UI language is not English.
  * Handle display of roles with expiration set to infinity
    correctly.
  * Allow editing of values in columns with the oid datatype
    which are not an actual row OID.
  * Make the Query Tool tab titles more concise and useful.
  * Fix support for bigint’s in JSONB data.
  * Update CodeMirror to 5.43.0 to resolve issues with
    auto-indent.
  * Ensure JSON data isn’t modified in-flight by psycopg2 when
    using View/Edit data.
  * Modify the Download as CSV option to use the same connection
    as the Query Tool its running in so temporary tables etc.
    can be used.
  * Fix context sub-menu alignment on Safari.
  * Update documentation screenshots as per new design.
  * Fix alignment of Close and Maximize button of Grant Wizard.
  * Add full support and testsfor all PG server side encodings.
  * Fix editing of table data with a JSON primary key.
  * Ignore exceptions in the logger.
  * Close connections gracefully when the user logs out of
    pgAdmin.
  * Fix alignment of checkbox to drop multiple schedules of
    pgAgent job.
  * Don’t exclude SELECT statements from transaction management
    in the Query Tool in case they call data-modifying functions.
  * Optimise display of Dependencies and Dependents, and use
    on-demand loading of rows in batches of 100.
  * Fix alignment of import/export toggle switch.
  * Prevent an error when closing the Sort/Filter dialogue with
    an empty filter string.
  * Fix alignment of Connection type toggle switch of pgagent.
  * Fix the query to set bytea_output so that read-only standbys
    don’t consider it a write query.
  * Add full support and testsfor all PG server side encodings.
  * Don’t embed docs and external sites in iframes, to allow the
    external sites to set X-FRAME-OPTIONS = DENY for security.
  * Add full support and testsfor all PG server side encodings.
  * Custom-encode forward slashes in URL parameters as Apache
    HTTPD doesn’t allow them in some cases.
  * Update CodeMirror to 5.43.0 to resolve issues with tab indent
    with use spaces enabled.
  * Ensure long queries don’t cause errors when downloading CSV
    in the Query Tool.
  * Disable the editor and execute functions whilst queries are
    executing.
  * Fix an issue where importing servers fails if a group already
    exists for a different user.
* Tue Mar  5 2019 ecsos@opensuse.org
- Update to pgadmin4 4.2
  - Bug fixes
  * Replace Bootstrap switch with Bootstrap4 toggle to improve
    the performance.
  * Replace the PyCrypto module with the cryptography module.
  * Fixed SQL for foreign table options.
  * Fixed execution time to show Hours part for long running
    queries in Query Tool.
  * Messages tab of query tool should be clear on subsequent
    execution of table/view using View/Edit Data.
  * Clear drop-down menu should be disabled for View/Edit Data.
  * Fixed Statistics panel hang issue for 1000+ tables.
  * Proper error should be thrown when server group is created
    with existing name.
  * Ensure long string should be wrap in alertify dialogs.
  * Ensure that output of the query should be displayed even if
    Data Output window is detached from the Query Tool.
  * Inline edbspl trigger functions should not be visible in
    Grant Wizard.
  * Proper SQL should be generated when create function with
    return type as custom type argument.
  * Ensure that database restriction of server dialog should work
    with special characters.
  * Ensure that Backup/Restore button should work on single
    click.
  * Fixed SQL for when clause while creating Trigger.
  * Proper SQL should be generated when creating/changing column
    with custom type argument.
  * Ensure that file format combo box value should be retained
    when hidden files checkbox is toggled.
  * Proper SQL should be generated when create procedure with
    custom type arguments.
  * Ensure that browser should warn before close or refresh.
  * Fixed EXEC script for procedures.
  * Proper SQL should be generated when create domain of type
    interval with precision.
  * Drop-down should be closed when click on any other toolbar
    button.
  * Fixed keyboard navigation for dialog tabs.
  * Increase frames splitter mouse hover area to make it easier
    to resize.
  * Fixed alignment of tree arrow icons for Internet Explorer.
  * Ensure object names in external process dialogues are
    properly escaped.
  * Correct order of Save and Cancel button for json/jsonb
    editing.
  * Data should be updated properly for FTS Configurations,
    FTS Dictionaries, FTS Parsers and FTS Templates.
  * Fixed unable to drop multiple Rules and Foreign Tables from
    properties tab.
  * Fixed Query Tool Initialization Error.
  * Fixed keyboard navigation for Select2 and Privilege cell in
    Backgrid.
  * Correct schema should be displayed in Materialized View
    dialog.
  * Fixed debugger issue for procedure inside package for EPAS
    servers.
  * Fix alignment of help messages in properties panels.
  * Fix alignment of submenu for Internet Explorer.
  * Ensure that grant wizard should list down functions for EPAS
    server running with no-redwood-compat mode.
  * Dashboard graph optimization.
  * Remove Python 2.6 code that’s now obsolete.
  * Expose the bind address in the Docker container via
    PGADMIN_BIND_ADDRESS.
  * Exclude HTTPExceptions from the all_exception_handler as they
    should be returned as-is.
- Rebase fix-python3-crypto-call.patch
* Tue Jan 15 2019 Antonio Larrosa <alarrosa@suse.com>
- Update to pgadmin4 4.1
  - Bug fixes
  * Fix SQL generated for tables with inherited columns.
  * Ensure the context menu works after a server is renamed.
  * Fix ordering of VACUUM options which changed in PG11.
  * Don’t show system catalogs in the schemas property list unless
    show system objects is enabled.
  * Fix help for the backup/restore dialogues.
  * Ensure that last row of table data should be visible and user
    will be able to add new row.
  * Make the browser more robust in the face of multibyte characters
    in SQL_ASCII databases.
- Update to pgadmin4 4.0
  - Features
  * Allow query plans to be downloaded as an SVG file.
  * New UI design.
  * Allow servers to be pre-loaded into container deployments.
  - Bug fixes
  * Increase the size of the resize handle of the edit grid text
    pop-out.
  * Fix handling of array types as inputs to the debugger.
  * Fix an issue that could cause the Query Tool to fail to render.
  * Display event trigger functions correctly on EPAS.
  * Further improvements to treeview restoration.
  * Run Postfix in the container build so passwords can be reset etc.
  * Add titles to the code areas of the Query Tool and Debugger to
    ensure that panels can be re-docked within them.
  * Fix a webpack issue that could cause the Query Tool to fail to
    render.
  * Ensure we display the relation name (and not the OID) in the
    locks table wherever possible.
  * Fix an encoding issue in the query tool.
  * Include the WHERE clause on EXCLUDE constraints in RE-SQL.
  * Fix an issue when user define Cast from smallint->text is created.
  * Hide Radio buttons that should not be shown on the maintenance
    dialogue.
  * Ensure that null values handled properly in CSV download.
  * Tweak the wording on the Grant Wizard.
  * Prevent attempts to bulk-drop schema objects.
  * Ensure the browser toolbar buttons work in languages other than
    English.
  * Allow horizontal sizing of the edit grid text pop-out.
  * Ensure auto complete should works when first identifier in the
    FROM clause needs quoting.
  * Ensure auto complete should works for columns from a
    schema-qualified table.
  * Ensure identifiers are properly displayed in the plan viewer.
  * Make the setup process more robust against aborted executions.
  * Fixed an issue while creating export job.
- Make pgadmin4-web suggest the pgadmin4-doc package instead of
  requiring it.
* Fri Nov 30 2018 Antonio Larrosa <alarrosa@suse.com>
- Update to pgadmin4 3.6
  - Features
  * Add support for dropping multiple objects at once from the
    collection Properties panel.
  * Add the ability to import and export server definitions from
    a config database
  - Bug fixes
  * Ensure previous notices are not removed from the Messages tab in
    the Query Tool if an error occurs during query execution.
  * Allow the selection order to be preserved in the Select2 control
    to fix column ordering in data Import/Export.
  * Allow use of 0 (integer) and empty strings as parameters in the debugger.
  * Properly report errors when debugging cannot be started.
  * Prevent the debugger controls being pressed again before previous
    processing is complete.
  * Fix toggle breakpoints buttons in the debugger.
  * Fix changes to the NOT NULL and default value options in the
    Table Dialogue.
  * Fix dropping of multiple functions/procedures at once.
* Wed Nov 14 2018 Jan Engelhardt <jengelh@inai.de>
- Compact description and trim first-person grammar.
- Rename pgadmin4-docs to pgadmin4-doc to be in line with
  the naming of other packages in openSUSE.
- Safeguard fdupes to not run over partition boundaries.
* Wed Nov  7 2018 Antonio Larrosa <alarrosa@suse.com>
- Update to pgadmin4 3.5
  - Features
  * Save the treeview state periodically, and restore it automatically when
    reconnecting.
  * Migrate from Bootstrap 3 to Bootstrap 4.
  - Bug fixes
  * Ensure that Utilities(Backup/Restore/Maintenence/Import-Export) should
    not be started if binary path is wrong and also added ‘Stop Process’ button
    to cancel the process.
  * Fix syntax error when creating new pgAgent schedules with a start date/time
    and exception.
  * Cleanup session files periodically.
  * Rename the ‘SQL Editor’ section of the Preferences to ‘Query Tool’ as it
    applies to the whole tool, not just the editor.
  * Fix CREATE Script functionality for EDB-Wrapped functions.
  * Fix connection garbage collector.
  * Purge connections from the cache on logout.
  * Ensure that utility existence check should work for schema and other child
    objects while taking Backup/Restore.
  * Fixed fatal error while launching the pgAdmin4 3.5. Update the version of
    the Flask to 0.12.4 for release.
* Mon Oct  8 2018 Antonio Larrosa <alarrosa@suse.com> - 3.4
- Update to pgadmin4 3.4
  - Features
  * Move all CSS into SCSS files for consistency and ease of colour maintenance etc.
  * Add optional data point markers and mouse-over tooltips to display values on graphs.
  * Add shortcuts for View Data and the Query tool to the Browser header bar.
  - Bug fixes
  * Ensure the runtime can startup properly if there are wide characters in the logfile path on Windows.
  * Fix handling of backslashes in the edit grid.
  * Ensure queries are no longer executed when dashboards are closed.
  * Fix support for the CLOB datatype in EPAS.
  * Fix logic around validation and highlighting of Sort/Filter in the Query Tool.
  * Ensure auto-complete works for objects in schemas other than public and pg_catalog.
  * Ensure changes to Query Tool settings from the Preferences dialogue are applied before executing queries.
  * Swap the Schema and Schemas icons and Catalog and Catalogs icons that had been used the wrong way around.
* Wed Oct  3 2018 Antonio Larrosa <alarrosa@suse.com> - 3.3
- Update to pgadmin4 3.3
  - Features
  * Add a geometry viewer that can render PostGIS data on a blank canvas or various map sources.
  * Added new backup/restore options for PostgreSQL 11. Added dump options for 'pg_dumpall'.
  * Add a Spanish translation.
  - Bug fixes
  * Stabilise feature tests for continuous running on CI systems.
  * Fixed debugger execution issues.
  * Ensure 'select all' and 'unselect all' working properly for pgAgent schedule.
  * Fix sort/filter dialog issue where it incorrectly requires ASC/DESC.
  * Ensure backup should work with '--data-only' and '--schema-only' for any format.
  * Fix keyboard shortcuts layout in the preferences panel.
  * Merge pgcli code with version 1.10.3, which is used for auto complete feature.
  * Ensure that refreshing a node also updates the Property list.
  * Ensure that refresh button on dashboard should refresh the table.
  * Handle connection errors properly in the query tool.
  * Make session implementation thread safe
  * Ensure external table node should be visible only for GPDB.
  * Fix auto scrolling issue in debugger on step in and step out.
  * Fix sort/filter dialog editing issue.
  * Ensure sort/filter dialog should display proper message after losing database connection.
  * Ensure sql for Role should be visible in SQL panel for GPDB.
  * When building the Windows installer, copy system Python packages before installing dependencies to ensure we don't end up with older versions than intended.
  * Correct the documentation of View/Edit data.
* Tue Aug 21 2018 Antonio Larrosa <alarrosa@suse.com> - 3.2
- Initial release of pgadmin4 3.2
